/* Thanks to Sandesh Karalkar for the original datepicker widget code */

function oeDatePicker()  {
 }
 
/**
*   Static variables
*/

/** The popup window containing the picker */
 oeDatePicker.gPopup  = null;
 
 
/** The original starting date and currently selected date */
 oeDatePicker.gOriginalDate = null; 
 oeDatePicker.gSelectedDate = null; 
 
 /* selected items */
 oeDatePicker.gSelectedMonthItem = null;
 oeDatePicker.gSelectedDayItem = null;
 
 oeDatePicker.gTodaysDate = new Date();
 
 oeDatePicker.gStartingDayOfWeek = 0; // 0 for Sunday, 1 for Monday, etc
 
/**
*   Set up the picker, called when the popup pops
*/
oeDatePicker.onpopupshowing = function( startDate ) {
	
	try {
		oeDatePicker.gStartingDayOfWeek = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_CALENDAR_START_DAY);
	} catch(e) {
		oeDatePicker.gStartingDayOfWeek = REMINDER_FOX_CALENDAR_START_DAY_DEFAULT;
	}	
	
	// redraw dates if neccessary
	if ( oeDatePicker.gStartingDayOfWeek != 0 ) {
		for ( var i = 0; i < 7; i++ ) {
			var dayItem = document.getElementById( "calDay" + i  );
			var modifiedNumber = i + oeDatePicker.gStartingDayOfWeek;
			modifiedNumber = reminderFox_mod( modifiedNumber , 7);			
		     dayItem.setAttribute( "value", g_reminderFoxBundle.getString("rf.options.day." + modifiedNumber + ".name.MMM"));
			
			// mark "Sunday" as Red
			var dayBox = document.getElementById( "oe-date-picker-month-day-" + (i+1) + "-header-box" );
			if ( modifiedNumber == 0 ) {
				dayBox.setAttribute( "class",  "oe-date-picker-month-days-header-class-red");
			}
			else {
				dayBox.setAttribute( "class",  "oe-date-picker-month-days-box-header-class");				
			}
			
		}
		   
	}
	
   oeDatePicker.gOriginalDate = new Date( startDate );
   oeDatePicker.gSelectedDate = new Date( startDate );
   
   // draw the year based on the selected date   
   oeDatePicker.redrawYear();

   // draw the month based on the selected date   
   var month = oeDatePicker.gSelectedDate.getMonth() + 1;
   var selectedMonthBoxItem = document.getElementById( "oe-date-picker-year-month-" + month + "-box"  );
   oeDatePicker.selectMonthItem( selectedMonthBoxItem );
   
   // draw in the days for the selected date
   oeDatePicker.redrawDays();
}
 
 
/**
*   Called when a day is clicked, close the picker and call the client's oncommand
*/
oeDatePicker.clickDay = function( newDayItemNumber ) {
   // get the clicked day
     
   var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + newDayItemNumber );
   
   var dayNumber = dayNumberItem.getAttribute( "value" );
   
   // they may have clicked an unfilled day, if so ignore it and leave the picker up
   if( dayNumber != "" )  {
         // set the selected date to what they clicked on
         oeDatePicker.gSelectedDate.setDate( dayNumber );
		 oeDatePicker.redrawDays();
		
		highlightReminderForDate( oeDatePicker.gSelectedDate.getMonth(), oeDatePicker.gSelectedDate.getDate()  );
   }
}


/**
* Called when a month box is clicked 
*/

oeDatePicker.clickMonth = function( newMonthItem, newMonthNumber ){
   // already selected, return
   
   if( oeDatePicker.gSelectedMonthItem  == newMonthItem )   {
      return;
   }

   // Avoid problems when changing months if the date is at the end of the month
   // i.e. if date is 31 march and you do a setmonth to april, the month would
   // actually be set to may, beacause april only has 30 days.
   // This is why we keep the original date around.
   var oldDate = oeDatePicker.gSelectedDate.getDate();
   var yearNumber = oeDatePicker.gSelectedDate.getFullYear();
   
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( yearNumber, newMonthNumber-1 );

   if ( oldDate > lastDayOfMonth )  {
       oeDatePicker.gSelectedDate.setDate(lastDayOfMonth);
   }
   
   // update the selected date   
   oeDatePicker.gSelectedDate.setMonth( newMonthNumber - 1 );
   
   // select Month   
   oeDatePicker.selectMonthItem( newMonthItem );
 
   // redraw days
   oeDatePicker.redrawDays();
}
 
oeDatePicker.getLastDayOfMonth = function( year, month  ) {
   var pastLastDate = new Date( year, month, 32 );
   var lastDayOfMonth = 32 - pastLastDate.getDate();
   
   return lastDayOfMonth;
}

/**
* Called when previous Year button is clicked 
*/

oeDatePicker.previousYearCommand = function() {
	// reset the reminder array, so all reminders will be re-added in case the year-change affects
	// them (like <1978> style reminders)
	calendarReminderArray = null;
   // update the selected date
   var oldDate = oeDatePicker.gSelectedDate.getDate();
   var oldYear = oeDatePicker.gSelectedDate.getFullYear(); 
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( (oldYear - 1), oeDatePicker.gSelectedDate.getMonth() );
	
	// handle leap year scenario (Feb. 29 is selected and then the year is changed)
   if ( oldDate > lastDayOfMonth )
   {
       oeDatePicker.gSelectedDate.setDate(lastDayOfMonth);
   }

   oeDatePicker.gSelectedDate.setFullYear( oldYear - 1 ); 
   
      repopulateListForYear( oldYear, oeDatePicker.gSelectedDate.getFullYear() );
   
   // redraw the year and the days   
   oeDatePicker.redrawYear();   
   oeDatePicker.redrawDays();

   	selectCalendarSync = false;
	highlightClosestUpcomingReminder( oeDatePicker.gSelectedDate  );   
	selectCalendarSync = true;
}


/**
* Called when next Year button is clicked 
*/

oeDatePicker.nextYearCommand = function() {
	// reset the reminder array, so all reminders will be re-added in case the year-change affects
	// them (like <1978> style reminders)
	calendarReminderArray = null;
   // update the selected date
   var oldDate = oeDatePicker.gSelectedDate.getDate();
   var oldYear = oeDatePicker.gSelectedDate.getFullYear(); 
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( (oldYear + 1), oeDatePicker.gSelectedDate.getMonth() );
	
	// handle leap year scenario (Feb. 29 is selected and then the year is changed)
   if ( oldDate > lastDayOfMonth )  {
       oeDatePicker.gSelectedDate.setDate(lastDayOfMonth);
   }   
   
   oeDatePicker.gSelectedDate.setFullYear( oldYear + 1 ); 
   
   // redraw the year and the days
   repopulateListForYear( oldYear , oeDatePicker.gSelectedDate.getFullYear() );
   
   oeDatePicker.redrawYear();
   oeDatePicker.redrawDays();

   selectCalendarSync = false;
	highlightClosestUpcomingReminder( oeDatePicker.gSelectedDate  );    
	selectCalendarSync = true;
}
 

/**
* Draw the year based in the selected date 
*/

oeDatePicker.redrawYear = function() {
   var yearTitleItem = document.getElementById( "oe-date-picker-year-title-text" );
   yearTitleItem.setAttribute( "value", oeDatePicker.gSelectedDate.getFullYear() );
}


/**
* Select a month box 
*/

oeDatePicker.selectMonthItem = function( newMonthItem ) {
   // clear old selection, if there is one
   
   if( oeDatePicker.gSelectedMonthItem != null )  {
      oeDatePicker.gSelectedMonthItem.setAttribute( "selected" , false );
   }

   if ( newMonthItem != null ) { 
  		// Set the selected attribute, used to give it a different style   
    	newMonthItem.setAttribute( "selected" , true );
   }
      
   // Remember new selection  
  oeDatePicker.gSelectedMonthItem = newMonthItem;
}


/**
* Select a day box 
*/

oeDatePicker.selectDayItem = function( newDayItem ) {
   // clear old selection, if there is one   
   if( oeDatePicker.gSelectedDayItem != null )   {
   	  oeDatePicker.gSelectedDayItem.setAttribute( "selected" , false );
      oeDatePicker.gSelectedDayItem.setAttribute( "selectedReminder" , false );
   }

   if( newDayItem != null )   {
         // Set the selected attribute, used to give it a different style
   		var reminderDay =  newDayItem.getAttribute( "reminder" );
    	if ( reminderDay == "true" ) { 
    		newDayItem.setAttribute( "selectedReminder" , true );
    	}
    	else {
    	  newDayItem.setAttribute( "selected" , true );
    	  newDayItem.setAttribute( "selectedReminder" , false );
    	}
   }
         
   // Remember new selection      
   oeDatePicker.gSelectedDayItem = newDayItem;
}


/**
* Redraw day numbers based on the selected date
*/

oeDatePicker.redrawDays = function( ) {
	var dayNumberBoxItem;
	
   // Write in all the day numbers
   var firstDate = new Date( oeDatePicker.gSelectedDate.getFullYear(), oeDatePicker.gSelectedDate.getMonth(), 1 );   
   var firstDayOfWeek = firstDate.getDay() - oeDatePicker.gStartingDayOfWeek;
   if ( firstDayOfWeek < 0 ) {
  	firstDayOfWeek =  firstDate.getDay() + (7 - oeDatePicker.gStartingDayOfWeek);
  }
   var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( oeDatePicker.gSelectedDate.getFullYear(), oeDatePicker.gSelectedDate.getMonth() )

   var currentFirstDate = new Date( oeDatePicker.gTodaysDate.getFullYear(), oeDatePicker.gTodaysDate.getMonth(), 1 );
   var firstDayOfCurrentDateWeek = currentFirstDate.getDay()  - oeDatePicker.gStartingDayOfWeek;
   if ( firstDayOfCurrentDateWeek < 0 ) {
  	firstDayOfCurrentDateWeek =  currentFirstDate.getDay() + (7 - oeDatePicker.gStartingDayOfWeek);
  }
 
   // clear the selected day item   
   oeDatePicker.selectDayItem( null ); 

   // embolden today's date
  	if ( oeDatePicker.gTodaysDate.getMonth() == oeDatePicker.gSelectedDate.getMonth()  && 
   			oeDatePicker.gTodaysDate.getYear() == oeDatePicker.gSelectedDate.getYear()) {	
   		dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" + (oeDatePicker.gTodaysDate.getDate() + firstDayOfCurrentDateWeek) + "-box"  );       		
	   	dayNumberBoxItem.setAttribute( "today" , true );
  	}
  	else {
   	    dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" +(oeDatePicker.gTodaysDate.getDate() + firstDayOfCurrentDateWeek) + "-box"  );       		 	   	
   		dayNumberBoxItem.setAttribute( "today" , false );
   	}
   
   if ( calendarReminderArray == null ) {
   		createCalendarReminderArray();
   	}

	var monthArray = calendarReminderArray[oeDatePicker.gSelectedDate.getMonth()];
	
   // redraw each day bax in the 7 x 6 grid 
   var dayNumber = 1;
   for( var dayIndex = 0; dayIndex < 42; ++dayIndex )  {
        // get the day text box
      	var dayNumberItem = document.getElementById( "oe-date-picker-month-day-text-" + (dayIndex + 1) );
        dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" + (dayIndex + 1) + "-box" );
        
		// clear old styles and tooltips
        dayNumberBoxItem.setAttribute( "reminder" , false );
        dayNumberBoxItem.setAttribute( "completedReminder" , false );        
        dayNumberBoxItem.setAttribute( "important" , false );
        dayNumberBoxItem.setAttribute("tooltip", "");
        
      // if it is an unfilled day ( before first or after last ), just set its value to "",
   	  // and don't increment the day number.       
      if( dayIndex < firstDayOfWeek || dayNumber > lastDayOfMonth )  {
         dayNumberItem.setAttribute( "value" , "" );         
      }
      else {
		var important = false;
         // set the value to the day number         
         dayNumberItem.setAttribute( "value" , dayNumber );         

         if ( monthArray != null ) {
         	var reminderDaysArray = monthArray[dayNumber-1];

          	if ( reminderDaysArray != null ) {
           	   	  // clear old tooltip
         	   	 var tooltipItem = document.getElementById( "day-"+dayNumber  +"-tooltip");
			     while (tooltipItem.hasChildNodes()) {
			    	 tooltipItem.removeChild(tooltipItem.firstChild);
			  	 }
				
				var reminderAdded = false;
				var completedReminderAdded = false;
         	   	for ( var  i = 0; i < reminderDaysArray.length; i++ ) {
					var 	reminder = reminderDaysArray[i];
					var completed = false;
					// don't add reminder to calendar widget if the event has been completed already
					if ( reminder.completedDate != null )  {
						var calendarDate = new Date(oeDatePicker.gSelectedDate.getFullYear(),oeDatePicker.gSelectedDate.getMonth(), dayNumber );			
						// continue if marked complete and the date is less than or equal to the reminder's date
						if ( reminderFox_compareDates(calendarDate, reminder.completedDate ) != 1 ) {					
							completed = true;
						}
					}
	         		important = 	reminder.priority == REMINDER_PRIORITY_IMPORTANT;
	         		if ( important && !completed) {
	         		   	dayNumberBoxItem.setAttribute( "important" , true );
	         		 }	         		 
						
					var reminderDescription = document.createElement("description");
					reminderDescription.setAttribute("value", reminder.summary);
					if ( important  && !completed) {
						reminderDescription.setAttribute("style", "color: red;");
					}
					tooltipItem.appendChild(reminderDescription);
					if ( completed ) {
						completedReminderAdded = true;
					}
					else {
						reminderAdded = true;
					}
     		    }
     		
     			if ( reminderAdded ) {
	     		   dayNumberBoxItem.setAttribute( "reminder" , true );
		           dayNumberBoxItem.setAttribute("tooltip", "day-"+dayNumber +"-tooltip");
     			}
     			else if ( completedReminderAdded ) {
     				dayNumberBoxItem.setAttribute( "completedReminder" , true );
		          	dayNumberBoxItem.setAttribute("tooltip", "day-"+dayNumber +"-tooltip");
     			}
	        }
         }
         
         // draw the day as selected
         if( dayNumber == oeDatePicker.gSelectedDate.getDate() ) 
         {
            dayNumberBoxItem = document.getElementById( "oe-date-picker-month-day-" + (dayIndex + 1) + "-box"  );
            oeDatePicker.selectDayItem( dayNumberBoxItem );
         }
         
         // advance the day number         
         ++dayNumber;  
      }
   }
 }

